const ll INF = 1e18;

#define VEI(w,e) ((E[e].u == w) ? E[e].v : E[e].u)
#define CAP(w,e) ((E[e].u == w) ? E[e].cap[0] - E[e].flow : E[e].cap[1] + E[e].flow)
#define ADD(w,e,f) E[e].flow += ((E[e].u == w) ? (f) : (-(f)))

struct Edge { int u, v; ll cap[2], flow; };

vi d, act;
vector<Edge> E;
vvi adj;

void addEdge(int x, int y, pair<ll, ll> c) {
    Edge e; e.u = x; e.v = y;
    e.cap[0] = c.first; e.cap[1] = c.second;
    adj[x].push_back(E.size()); adj[y].push_back(E.size());
    E.push_back(e);
}

bool bfs(int s, int t) {
    queue<int> Q;
    d = vi(adj.size(), -1);
    d[t] = 0;
    Q.push(t);
    while (not Q.empty()) {
        int u = Q.front(); Q.pop();
        for (int i=0; i < int(adj[u].size()); ++i) {
            int e = adj[u][i], v = VEI(u, e);
            if (CAP(v, e) > 0 and d[v] == -1) {
                d[v] = d[u] + 1;
                Q.push(v);
            }
        }
    }
    return d[s] >= 0;
}

ll dfs(int u, int t, ll bot) {
    if (u == t) return bot;
    for (; act[u] < int(adj[u].size()); ++act[u]) {
        int e = adj[u][act[u]];
        if (CAP(u, e) > 0 and d[u] == d[VEI(u, e)] +1) {
            ll inc = dfs(VEI(u, e),t,min(bot,CAP(u,e)));
            if (inc) {
                ADD(u, e, inc);
                return inc;
            }
        }
    }
    return 0;
}

ll maxflow(int s, int t) {
    for (int i=0; i < int(E.size()); ++i) E[i].flow = 0;
    ll flow = 0, bot;
    while (bfs(s, t)) {
        act = vi(adj.size(), 0);
        while((bot = dfs(s, t, INF))) flow += bot;
    }
    return flow;
}